__gnu_cxx::__alloc_traits< _Alloc, typename > Struct Template Reference
Utilities » Memory » Allocators
Inheritance diagram for __gnu_cxx::__alloc_traits< _Alloc, typename >:
[legend]

## Public Types

typedef std::allocator_traits< _Alloc > | _Base_type
typedef _Alloc | allocator_type
typedef _Base_type::const_pointer | const_pointer
typedef const value_type & | const_reference
using | const_void_pointer = typename _Ptr< __cv_pointer, const void >::type
typedef _Base_type::difference_type | difference_type
using | is_always_equal = __detected_or_t< typename is_empty< _Alloc >::type, __equal, _Alloc >
typedef _Base_type::pointer | pointer
using | propagate_on_container_copy_assignment = __detected_or_t< false_type, __pocca, _Alloc >
using | propagate_on_container_move_assignment = __detected_or_t< false_type, __pocma, _Alloc >
using | propagate_on_container_swap = __detected_or_t< false_type, __pocs, _Alloc >
template<typename _Tp >
using | rebind_alloc = __alloc_rebind< _Alloc, _Tp >
template<typename _Tp >
using | rebind_traits = allocator_traits< rebind_alloc< _Tp > >
typedef value_type & | reference
typedef _Base_type::size_type | size_type
typedef _Base_type::value_type | value_type
using | void_pointer = typename _Ptr< __v_pointer, void >::type

## Static Public Member Functions

static constexpr bool | _S_always_equal ()
static constexpr bool | _S_nothrow_move ()
static void | _S_on_swap (_Alloc &__a, _Alloc &__b)
static constexpr bool | _S_propagate_on_copy_assign ()
static constexpr bool | _S_propagate_on_move_assign ()
static constexpr bool | _S_propagate_on_swap ()
static _Alloc | _S_select_on_copy (const _Alloc &__a)
static _GLIBCXX_NODISCARD pointer | allocate (_Alloc &__a, size_type __n)
static _GLIBCXX_NODISCARD pointer | allocate (_Alloc &__a, size_type __n)
static _GLIBCXX_NODISCARD pointer | allocate (_Alloc &__a, size_type __n, const_void_pointer __hint)
static _GLIBCXX_NODISCARD pointer | allocate (_Alloc &__a, size_type __n, const_void_pointer __hint)
template<typename _Ptr , typename... _Args>
static std::enable_if< __is_custom_pointer< _Ptr >::value >::type | construct (_Alloc &__a, _Ptr __p, _Args &&... __args) noexcept(noexcept(_Base_type::construct(__a, std::__to_address(__p), std::forward< _Args >(__args)...)))
template<typename _Tp , typename... _Args>
static auto | construct (_Alloc &__a, _Tp *__p, _Args &&... __args) noexcept(noexcept(_S_construct(__a, __p, std::forward< _Args >(__args)...))) -> decltype(_S_construct(__a, __p, std::forward< _Args >(__args)...))
template<typename _Tp , typename... _Args>
static auto | construct (_Alloc &__a, _Tp *__p, _Args &&... __args) noexcept(noexcept(_S_construct(__a, __p, std::forward< _Args >(__args)...))) -> decltype(_S_construct(__a, __p, std::forward< _Args >(__args)...))
static void | deallocate (_Alloc &__a, pointer __p, size_type __n)
static void | deallocate (_Alloc &__a, pointer __p, size_type __n)
template<typename _Ptr >
static std::enable_if< __is_custom_pointer< _Ptr >::value >::type | destroy (_Alloc &__a, _Ptr __p) noexcept(noexcept(_Base_type::destroy(__a, std::__to_address(__p))))
template<typename _Tp >
static void | destroy (_Alloc &__a, _Tp *__p) noexcept(noexcept(_S_destroy(__a, __p, 0)))
template<typename _Tp >
static void | destroy (_Alloc &__a, _Tp *__p) noexcept(noexcept(_S_destroy(__a, __p, 0)))
static size_type | max_size (const _Alloc &__a) noexcept
static size_type | max_size (const _Alloc &__a) noexcept
static _Alloc | select_on_container_copy_construction (const _Alloc &__rhs)

## Protected Types

template<typename _Tp >
using | __c_pointer = typename _Tp::const_pointer
template<typename _Tp >
using | __cv_pointer = typename _Tp::const_void_pointer
template<typename _Tp >
using | __equal = typename _Tp::is_always_equal
template<typename _Tp >
using | __pocca = typename _Tp::propagate_on_container_copy_assignment
template<typename _Tp >
using | __pocma = typename _Tp::propagate_on_container_move_assignment
template<typename _Tp >
using | __pocs = typename _Tp::propagate_on_container_swap
template<typename _Tp >
using | __pointer = typename _Tp::pointer
template<typename _Tp >
using | __v_pointer = typename _Tp::void_pointer

## Detailed Description

### template<typename _Alloc, typename = typename _Alloc::value_type>
struct __gnu_cxx::__alloc_traits< _Alloc, typename >

Uniform interface to C++98 and C++11 allocators.

Definition at line 50 of file ext/alloc_traits.h.

## Member Typedef Documentation

## const_void_pointer

template<typename _Alloc >

using std::allocator_traits< _Alloc >::const_void_pointer = typename _Ptr<__cv_pointer, const void>::type

inherited

The allocator's const void pointer type.

`Alloc::const_void_pointer` if that type exists, otherwise `pointer_traits<pointer>::rebind<const void>`

Definition at line 151 of file bits/alloc_traits.h.

## is_always_equal

template<typename _Alloc >

using std::allocator_traits< _Alloc >::is_always_equal = __detected_or_t<typename is_empty<_Alloc>::type, __equal, _Alloc>

inherited

Whether all instances of the allocator type compare equal.

`Alloc::is_always_equal` if that type exists, otherwise `is_empty<Alloc>::type`

Definition at line 202 of file bits/alloc_traits.h.

## propagate_on_container_copy_assignment

template<typename _Alloc >

using std::allocator_traits< _Alloc >::propagate_on_container_copy_assignment = __detected_or_t<false_type, __pocca, _Alloc>

inherited

How the allocator is propagated on copy assignment.

`Alloc::propagate_on_container_copy_assignment` if that type exists, otherwise `false_type`

Definition at line 175 of file bits/alloc_traits.h.

## propagate_on_container_move_assignment

template<typename _Alloc >

using std::allocator_traits< _Alloc >::propagate_on_container_move_assignment = __detected_or_t<false_type, __pocma, _Alloc>

inherited

How the allocator is propagated on move assignment.

`Alloc::propagate_on_container_move_assignment` if that type exists, otherwise `false_type`

Definition at line 184 of file bits/alloc_traits.h.

## propagate_on_container_swap

template<typename _Alloc >

using std::allocator_traits< _Alloc >::propagate_on_container_swap = __detected_or_t<false_type, __pocs, _Alloc>

inherited

How the allocator is propagated on swap.

`Alloc::propagate_on_container_swap` if that type exists, otherwise `false_type`

Definition at line 193 of file bits/alloc_traits.h.

## void_pointer

template<typename _Alloc >

using std::allocator_traits< _Alloc >::void_pointer = typename _Ptr<__v_pointer, void>::type

inherited

The allocator's void pointer type.

`Alloc::void_pointer` if that type exists, otherwise `pointer_traits<pointer>::rebind<void>`

Definition at line 143 of file bits/alloc_traits.h.

## Member Function Documentation

## allocate() [1/4]

template<typename _Alloc >

static _GLIBCXX_NODISCARD pointer std::allocator_traits< _Alloc >::allocate | ( | _Alloc & | __a,
|  | size_type | __n
| ) |  |

inline static inherited

Allocate memory.

Parameters

  __a | An allocator.
  __n | The number of objects to allocate space for.

Calls `a.allocate(n)`

Definition at line 304 of file bits/alloc_traits.h.

Referenced by std::__allocate_guarded().

## allocate() [2/4]

template<typename _Alloc , typename = typename _Alloc::value_type>

static _GLIBCXX_NODISCARD pointer std::allocator_traits< _Alloc >::allocate

inline static

Allocate memory.

Parameters

  __a | An allocator.
  __n | The number of objects to allocate space for.

Calls `a.allocate(n)`

Definition at line 304 of file bits/alloc_traits.h.

## allocate() [3/4]

template<typename _Alloc >

static _GLIBCXX_NODISCARD pointer std::allocator_traits< _Alloc >::allocate | ( | _Alloc & | __a,
|  | size_type | __n,
|  | const_void_pointer | __hint
| ) |  |

inline static inherited

Allocate memory.

Parameters

  __a | An allocator.
  __n | The number of objects to allocate space for.
  __hint | Aid to locality.

Returns
  Memory of suitable size and alignment for n objects of type `value_type`

Returns `a.allocate(n, hint)` if that expression is well-formed, otherwise returns `a.allocate(n)`

Definition at line 319 of file bits/alloc_traits.h.

## allocate() [4/4]

template<typename _Alloc , typename = typename _Alloc::value_type>

static _GLIBCXX_NODISCARD pointer std::allocator_traits< _Alloc >::allocate

inline static

Allocate memory.

Parameters

  __a | An allocator.
  __n | The number of objects to allocate space for.
  __hint | Aid to locality.

Returns
  Memory of suitable size and alignment for n objects of type `value_type`

Returns `a.allocate(n, hint)` if that expression is well-formed, otherwise returns `a.allocate(n)`

Definition at line 319 of file bits/alloc_traits.h.

## construct() [1/2]

template<typename _Alloc >
template<typename _Tp , typename... _Args>

static auto std::allocator_traits< _Alloc >::construct | ( | _Alloc & | __a,
|  | _Tp * | __p,
|  | _Args &&... | __args
| ) |  | -> decltype(_S_construct(__a, __p, std::forward<_Args>(__args)...))

inline static noexcept inherited

Construct an object of type `_Tp`.

Parameters

  __a | An allocator.
  __p | Pointer to memory of suitable size and alignment for Tp
  __args | Constructor arguments.

Calls `__a.construct(__p, std::forward<Args>(__args)...)` if that expression is well-formed, otherwise uses placement-new to construct an object of type _Tp at location __p from the arguments __args...

Definition at line 346 of file bits/alloc_traits.h.

## construct() [2/2]

template<typename _Alloc , typename = typename _Alloc::value_type>
template<typename _Tp , typename... _Args>

static auto std::allocator_traits< _Alloc >::construct | ( | typename _Tp | ,
|  | typename... | _Args
| ) |  |

inline static noexcept

Construct an object of type `_Tp`.

Parameters

  __a | An allocator.
  __p | Pointer to memory of suitable size and alignment for Tp
  __args | Constructor arguments.

Calls `__a.construct(__p, std::forward<Args>(__args)...)` if that expression is well-formed, otherwise uses placement-new to construct an object of type _Tp at location __p from the arguments __args...

Definition at line 346 of file bits/alloc_traits.h.

## deallocate() [1/2]

template<typename _Alloc >

static void std::allocator_traits< _Alloc >::deallocate | ( | _Alloc & | __a,
|  | pointer | __p,
|  | size_type | __n
| ) |  |

inline static inherited

Deallocate memory.

Parameters

  __a | An allocator.
  __p | Pointer to the memory to deallocate.
  __n | The number of objects space was allocated for.

Calls `a.deallocate(p, n)`

Definition at line 331 of file bits/alloc_traits.h.

Referenced by std::__allocated_ptr< _Alloc >::~__allocated_ptr().

## deallocate() [2/2]

template<typename _Alloc , typename = typename _Alloc::value_type>

static void std::allocator_traits< _Alloc >::deallocate

inline static

Deallocate memory.

Parameters

  __a | An allocator.
  __p | Pointer to the memory to deallocate.
  __n | The number of objects space was allocated for.

Calls `a.deallocate(p, n)`

Definition at line 331 of file bits/alloc_traits.h.

## destroy() [1/2]

template<typename _Alloc >
template<typename _Tp >

static void std::allocator_traits< _Alloc >::destroy | ( | _Alloc & | __a,
|  | _Tp * | __p
| ) |  |

inline static noexcept inherited

Destroy an object of type _Tp.

Parameters

  __a | An allocator.
  __p | Pointer to the object to destroy

Calls `__a.destroy(__p)` if that expression is well-formed, otherwise calls `__p->~_Tp()`

Definition at line 361 of file bits/alloc_traits.h.

## destroy() [2/2]

template<typename _Alloc , typename = typename _Alloc::value_type>
template<typename _Tp >

static void std::allocator_traits< _Alloc >::destroy | ( | typename _Tp |  | ) |

inline static noexcept

Destroy an object of type _Tp.

Parameters

  __a | An allocator.
  __p | Pointer to the object to destroy

Calls `__a.destroy(__p)` if that expression is well-formed, otherwise calls `__p->~_Tp()`

Definition at line 361 of file bits/alloc_traits.h.

## max_size() [1/2]

template<typename _Alloc >

static size_type std::allocator_traits< _Alloc >::max_size | ( | const _Alloc & | __a | ) |

inline static noexcept inherited

The maximum supported allocation size.

Parameters

  __a | An allocator.

Returns
  `__a.max_size()` or `numeric_limits<size_type>::max()`

Returns `__a.max_size()` if that expression is well-formed, otherwise returns `numeric_limits<size_type>::max()`

Definition at line 373 of file bits/alloc_traits.h.

## max_size() [2/2]

template<typename _Alloc , typename = typename _Alloc::value_type>

static size_type std::allocator_traits< _Alloc >::max_size

inline static noexcept

The maximum supported allocation size.

Parameters

  __a | An allocator.

Returns
  `__a.max_size()` or `numeric_limits<size_type>::max()`

Returns `__a.max_size()` if that expression is well-formed, otherwise returns `numeric_limits<size_type>::max()`

Definition at line 373 of file bits/alloc_traits.h.

Referenced by std::forward_list< _Tp, _Alloc >::max_size(), and std::list< _Tp, _Alloc >::max_size().

## select_on_container_copy_construction()

template<typename _Alloc >

static _Alloc std::allocator_traits< _Alloc >::select_on_container_copy_construction | ( | const _Alloc & | __rhs | ) |

inline static inherited

Obtain an allocator to use when copying a container.

Parameters

  __rhs | An allocator.

Returns
  `__rhs.select_on_container_copy_construction()` or __rhs

Returns `__rhs.select_on_container_copy_construction()` if that expression is well-formed, otherwise returns __rhs

Definition at line 385 of file bits/alloc_traits.h.

The documentation for this struct was generated from the following file:

- ext/alloc_traits.h